; TILOCK92 program for the TI-92
; John Grafton, 1996

  @program      prog_code,prog_name
  include       macros.h

; start of FARGO program

prog_code:
  bsr           intro
  bsr           mainmenu

exit:
  rts

intro:
  jsr           flib[clr_scr]           ; clear the screen  
  move.w        #30,d0
  move.w        #30,d1
  move.w        #209,d2
  move.w        #97,d3
  bsr           drawbox

  SetFont       #1
  WriteStr      #65,#40,#1,maintitle
  SetFont       #0
  WriteStr      #90,#55,#1,grafware1
  WriteStr      #92,#65,#1,grafware2
  WriteStr      #70,#75,#1,grafware3

  jsr           flib[idle_loop]

  rts

mainmenu:
  jsr           flib[clr_scr]           ; clear the screen

  move.w        #0,d0
  move.w        #0,d1
  move.w        #239,d2
  move.w        #25,d3
  bsr           drawbox

  move.w        #0,d0
  move.w        #0,d1
  move.w        #239,d2
  move.w        #121,d3
  bsr           drawbox

  SetFont       #2
  WriteStr      #40,#10,#1,maintitle
  SetFont       #1
  WriteStr      #20,#30,#1,shutdown
  WriteStr      #20,#40,#1,options
  WriteStr      #20,#50,#1,quit
  SetFont       #0
  WriteStr      #7,#100,#1,grafware1
  WriteStr      #7,#110,#1,credit

  jsr           flib[idle_loop]

  cmp.w         #$31,d0                 ; press F1 to shutdown
  beq           do_shutdown     
  cmp.w         #$32,d0                 ; press F2 for option menu
  beq           do_options
  cmp.w         #$33,d0                 ; press F3 to quit
  beq           exitmain
  cmp.w         #$108,d0                ; press ESC
  beq           exitmain

  bra           mainmenu

do_options:
  bsr           the_options
  bra           mainmenu

do_shutdown:
  bsr           the_shutdown
  bra           mainmenu
  
exitmain:
  rts

the_options:
  jsr           flib[clr_scr]

  move.w        #0,d0
  move.w        #0,d1
  move.w        #239,d2
  move.w        #25,d3
  bsr           drawbox

  move.w        #0,d0
  move.w        #0,d1
  move.w        #239,d2
  move.w        #121,d3
  bsr           drawbox

  SetFont       #2
  WriteStr      #40,#10,#1,maintitle
  SetFont       #1
  WriteStr      #7,#35,#1,protecto
  WriteStr      #7,#45,#1,enter
  SetFont       #0
  WriteStr      #7,#110,#1,grafware1

getpass2:
getkey2:
  move.b        length(pc),d1
  lea           password(pc),a1
nextkey2:
  jsr           flib[idle_loop]
  move.b        (a1)+,d2
  cmp.b         d0,d2
  bne           getkey2
  DBGT.b        d1,nextkey2
  bra           correct2

correct2:
  jsr           flib[clr_scr]
  move.w        #0,d0
  move.w        #0,d1
  move.w        #239,d2
  move.w        #25,d3
  bsr           drawbox

  move.w        #0,d0
  move.w        #0,d1
  move.w        #239,d2
  move.w        #121,d3
  bsr           drawbox

  SetFont       #2
  WriteStr      #40,#10,#1,maintitle
  SetFont       #1
  WriteStr      #7,#45,#1,enternewp
  SetFont       #0
  WriteStr      #7,#100,#1,grafware1
  WriteStr      #7,#110,#1,credit

  move.b        #0,d2
  lea           length(pc),a3
  lea           password(pc),a2

getnextkey:
  jsr           flib[idle_loop]
  cmp.b         #13,d0
  beq           exitop
  add.b         #1,d2
  move.b        d0,(a2)+
  jmp           getnextkey

exitop:
  sub.b         #1,d2
  move.b        d2,(a3)

done:
  rts

the_shutdown:
  jsr           flib[clr_scr]
  trap          #4

  move.w        #$0,-(a7)
  jsr           romlib[set_activity]
  lea           2(a7),a7

  jsr           graylib7[on]            ; Turn on 7-grayscale
  move.l        graylib7[plane0],a1     ; Remember plane
  move.l        graylib7[plane1],a2     ; Remember plane
  lea           planes(pc),a5           ; Set pointer to compressed data !
  move.w        #3840,d7                ; Number of bytes to paint.
  jsr           fargray[put3planepic]   ; Put Picture on Screen !

  jsr           flib[idle_loop]         ; Wait until keypressed.
  jsr           graylib7[off]           ; Turn off Grayscale

; make box in middle of picture
  move.w        #52,theYpixel
  move.w        #62,theXpixel
xloop:
yloop:
  move.w        theYpixel,d4
  move.w        d4,-(a7)
  move.w        theXpixel,d4
  move.w        d4,-(a7)
  jsr           flib[pixel_off]         ; print a pixel
  add.l         #4,a7

  addi          #1,theYpixel
  cmpi          #75,theYpixel
  bls           yloop                   ; loop the Y loop

  move.w        #52,theYpixel
  addi          #1,theXpixel
  cmpi          #177,theXpixel
  bls           xloop                   ; loop the X loop

  SetFont       #2
  WriteStr      #84,#59,#1,enter

getpass:
getkey:
  move.b        length(pc),d1
  lea           password(pc),a1
nextkey:
  jsr             flib[idle_loop]
  move.b          (a1)+,d2
  cmp.b           d0,d2
  bne             getkey
  DBGT.b          d1,nextkey
  bra             correct

correct:
  
  rts

; ***************
; ** functions **
; ***************

;----------------------------------------------------------------------------
; fline()
; (taken from the linelib library)
;
; Function: Draws a line, _FAST_
;
; Input:    D0.W = X1
;           D1.W = Y1
;           D2.W = X2
;           D3.W = Y2
;           A0   = Address to top left corner (usually $4440)
;              
;----------------------------------------------------------------------------
fline:
 movem.l d0-d7/a0,-(a7)
 cmp.w	 d0,d2
 bcc DXpos
 exg d0,d2
 exg d1,d3
DXpos:
 move.w  d1,d4
 move.w  d1,d5
 lsl.w	 #5,d4
 lsl.w	 #1,d5
 sub.w	 d5,d4
 move.w  d0,d5
 lsr.w	 #3,d5
 add.w	 d5,d4
 move.w  d0,d5
 not	 d5
 and.b	 #$07,d5
 adda	 d4,a0
 bset.b  d5,(a0)
 move.b  d5,d6
 moveq	 #1,d5
 lsl	 d6,d5
 move.w  d2,d6
 sub.w	 d0,d6
ChY:
 cmp.w	 d1,d3
 bcc DYpos
 moveq	 #-30,d4
 move.w  d1,d7
 sub.w	 d3,d7
 bra PutP1
DYpos:
 moveq	 #30,d4
 move.w  d3,d7
 sub.w	 d1,d7
PutP1:		 ; d4 = YAI, d5 = bit, d6 = DX, d7 = DY, A0 = Ptr
 cmp.w	 d0,d2
 bne DotsNE
 cmp.w	 d1,d3
 beq LineDone
DotsNE:
 cmp.w	 d6,d7
 bcc DY_Greater
 move.l  d6,d2
 subq	 #1,d2	 ; d2 = number of pixels to be plot
 move.w  d7,d3
 sub.w	 d6,d3	 ; d3 = dy-dx
 asl.w	 #1,d3	 ; d3 = ai
 lsl.w	 #1,d7	 ; d7 = bi
 sub.w	 d7,d6
 neg	 d6	 ; d6 = d
RepX:
 or.w	 d6,d6
 bmi X_DNeg
 adda	 d4,a0
 add.w	 d3,d6
 bra IncX
X_DNeg:
 add.w	 d7,d6
IncX:
 ror.b	 #1,d5
 bcc X_SameByte
 addq	 #1,a0
X_SameByte:
 or.b	 d5,(a0)
 dbra	 d2,RepX
 bra LineDone
DY_Greater:
 move.l  d7,d3
 subq	 #1,d3	 ; d3 = number of pixels to be plot
 move.w  d6,d2
 sub.w	 d7,d2	 ; d2 = dx-dy
 lsl.w	 #1,d2	 ; d2 = ai
 lsl.w	 #1,d6	 ; d6 = bi
 sub.w	 d6,d7
 neg	 d7	 ; d7 = d
RepY:
 or.w	 d7,d7
 bmi Y_DNeg
 ror.b	 #1,d5
 bcc Y_SameByte
 addq	 #1,a0
Y_SameByte:
 add.w	 d2,d7
 bra IncY
Y_DNeg:
 add.w	 d6,d7
IncY:
 adda	 d4,a0
 or.b	 d5,(a0)
 dbra	 d3,RepY
LineDone:
 movem.l (a7)+,d0-d7/a0
 rts

; drawbox
; input: d0.w : X upper left corner
;        d1.w : Y upper left corner
;        d2.w : X lower right corner
;        d3.w : Y lower right corner
; output: none

drawbox:
  ; Draw top line
  move.w        d3,tempdat
  move.w        d1,d3           ; y
  move.l        #$4440,a0       ; address of video mem
  bsr           fline
  move.w        tempdat,d3

  ; Draw left line
  move.w        d2,tempdat
  move.w        d0,d2           ; x
  move.l        #$4440,a0       ; address of video mem
  bsr           fline
  move.w        tempdat,d2

  ; Draw right line
  move.w        d0,tempdat
  move.w        d2,d0           ; x coordinate
  move.l        #$4440,a0       ; address of video mem
  bsr           fline
  move.w        tempdat,d0

  ; Draw bottom line
  move.w        d1,tempdat
  move.w        d3,d1           ; y
  move.l        #$4440,a0       ; address of video mem
  bsr           fline
  move.w        tempdat,d1

  rts

; data
tempdat         dc.w 0
maintitle       dc.b "TI-Lock 92 ver 1.2",0
grafware1       dc.b "Grafware, 1996",0
grafware2       dc.b "John Grafton",0
grafware3       dc.b "NuTcAsE79@geocities.com",0
shutdown        dc.b "1.) Shut down and lock",0
options         dc.b "2.) Change password",0
quit            dc.b "3.) Quit",0
protect         dc.b "This wonderful calc is protected.",0
protecto        dc.b "You must enter current password!",0
enternewp       dc.b "Enter your new password:  ",0
theXpixel       dc.w 0
theYpixel       dc.w 0
enter           dc.b "Password:",0
password        dc.b "jgraf",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
length          dc.b 4

planes:
        INCBIN  "tick.bin"

credit:
        dc.b "Converted using FarGray v2.0 by JKKN 1/97",0

planeno         dc.b 0

; program's description as it appears in the TI-92's fargo shell
prog_name:
                dc.b "TI-Lock 92 ver 1.2",0

; end of FARGO program 
  reloc_open
  add_library flib     
  add_library fargray
  add_library graylib7
  add_library romlib   
  reloc_close
  end
